(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2013 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)
type stats = { run : int;
               tree_size : int;
               fetch_trans_cache_access : int;
               fetch_trans_cache_hit : int;
               eval_trans_cache_access : int;
               eval_trans_cache_hit : int;
             }
module Make (T : Tree.S) :
  sig
    val eval : Ata.t -> T.t -> T.node list -> T.node list
    val full_eval : Ata.t -> T.t -> T.node list -> (State.t * T.node list) list
    val stats : unit -> stats
  end
